/* LSDino/386 v.54 Beta, Main Include File */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>





#ifndef max
#define max(a,b)  ((a>b)?a:b)
#endif

#ifdef MAIN
     #include "lsdincl\potleaf.h"
     #include "lsdincl\sin.h"
     #include "lsdincl\sqrt.h"
     #include "lsdincl\cos.h"

     short delaytime=100;

     /* This defines what images we can/cannot use. */

     int numimages=0,numpals=0;
     char okimgs[255];

     /* Changing this may require you to change NUMMASKS defined below */

     unsigned char *masks[]={potleaf1,potleaf2,fullmask};

     char *version="LSDino/386";
     char *vernum="v1.00 Alpha";

     unsigned char dacbox[256][3];
     unsigned char fadeto[256][3];
     int forcerotate=0;
     int paltype=0,palforce=0;
     char *palrefc="123456789";
     char *palrefa="QWERTYUIO";
     char *palrefb="ASDFGHJKL";

     char palettes[127][3];

     int palwhite,palblack;

     char nopalchange=0;
     char avg_first=1,avg_second=1;
     char loopey[] = {0, 1, 2, 3, 2, 1};

     char okrandimag[] = {0,1,2,3,4,5,6,7,23,31,24,8,25,17,28,26,27,16,9,34,35,36,37,38,40,41,42,43,44,45};
     unsigned short *acidtable;
     unsigned short *acidtabley;
     short pal[3];
     char loopster[] = {-5,-4,-4,-3,-2,-1,-1,0,0,0,1,1,2,3,4,4,5,5,5,4,4,3,2,1,0,-1,-2,-3,-4,-4,-5,-5};
     char bigloopster[] = {1,4,6,8,10,12,14,16,18,20,20,18,16,14,12,10,8,6,4,1};
     char dropped_acid=0;
     char far *screenbuffer;

#else
     extern char *version;
     extern char *vernum;


     extern char nopalchange;
     extern int palwhite,palblack;
     extern int numimages,numpals;
     extern char far *screenbuffer;
     extern long potleaf1[],potleaf2[],fullmask[];
     extern long sintable[],sqrttable[],costable[],tantable[];
     extern short delaytime;
     extern char okimgs[]; 
     extern unsigned char *masks[];
     extern unsigned char dacbox[256][3];
     extern unsigned char fadeto[256][3];
     extern int forcerotate;
     extern int paltype,palforce;
     extern char *palref;
     extern char *palrefa;
     extern char *palrefb;
     extern char palettes[][3];  
     extern char avg_first,avg_second;
     extern char loopey[];
     extern unsigned short *acidtable;
     extern unsigned short *acidtabley;
     extern short pal[3];
     extern char loopster[];
     extern char bigloopster[];
     extern char dropped_acid;
#endif

/****************************************************************************
 *
 * Function Definitions
 *
 ***************************************************************************/

/* Acidtrip.c */


/* MISC.C */

void putpixtype(int x, int y, int color,int type);
void notenoughmem(char *s);


/* ?.C */

void distort(int type,int x,int y,int *color);
void read_data(void);
void range_check(double x);
void pseudodelay(int time);

/* Translat.c */

void dotable(char *filename);
void translate_table(unsigned short int *trsltable);

/* Lowlevel.c */
void delay(unsigned long l);
void waitretrace(void);
void set_dac(char start[3], char middle[3], char finish[3]);
void set_fade(char start[3], char middle[3], char finish[3]);
void vgamode(void);
void txtmode(void);
unsigned char getpix(int x,int y);
void putpix(int x,int y,unsigned char color);
void rgb(unsigned char color, char r, char g, char b);
void fadeto_dac_slows(void);
void fadeto_dac(void);
void rotate_dac(void);
void rotate_dacbak(void);
void update_dac(void);

/****************************************************************************
 *
 * Defines Section
 *
 ***************************************************************************/

/* Bounding-size for the bouncing ball */

#define lenx 50
#define leny 40

/* Maximum length for an effect done in the acid routine. */
#define ACID_LEN 200

/* These are used for the palette effect where bar(s) of color move around
   over the current palette */
#define SIZE2 (SIZE[cycles]/2)
#define MAXCYCLE 3

/* Various ways of putting a pixel on to the screen, used for putpixtype
   calls */
#define NORMAL 0
#define XOR 1
#define OR  2
#define AND 3
#define AVG 4
#define BLEND 5
#define DBLAVG 6

/* 2 Palette types, one they are in full bands of 3 colors, the other they are
   divided up into 5 bands, going Color 1 Color 2 Color 3 Color 1 Color 2 ...
   etc.. .*/
#define PALFULL 0  
#define PALDIV  1

#define NUMMASKS 3
#define DISTORTX 0x010
#define DISTORTY 0x020
#define DISTORTZ 0x040
#define ICECREAM 0x080
#define SWIRL    0x100

#define CLRQUAD 32 /* colors per a quadrant */

#define NUMPAL numpals
#define PALWHITE palwhite
#define PALBLACK palblack
#define BASEADDR 0x220
#define NUMIMAG numimages
#define t320(x) ((x << 8) + (x << 6))

/*
 * This is all #defined simply so it'll go alot faster, rather than having
 * to be a function which is a called and goes slow upon calling.
*/

#define fmemcpy(s,d,len) \
{\
        int zzz=0;\
        while(zzz<(unsigned int)len){\
                *(s+zzz)=*(d+zzz);\
                zzz++;\
        }\
}

/****************************************************************************
 *
 * Structure Definitions
 *
 ***************************************************************************/


typedef struct{
	int 	xoff,
		multiplier,
		origmultiplier;
}xyrec;

